// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_auction_additional_bid_signature.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesAuctionAdditionalBidSignature[] = {
"key",
"signature",
};


}  // namespace 

AuctionAdditionalBidSignature* AuctionAdditionalBidSignature::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  AuctionAdditionalBidSignature* dictionary = MakeGarbageCollected<AuctionAdditionalBidSignature>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "AuctionAdditionalBidSignature";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 AuctionAdditionalBidSignature::AuctionAdditionalBidSignature() {
  
}

 AuctionAdditionalBidSignature::AuctionAdditionalBidSignature(v8::Isolate* isolate) {
  
}

















void AuctionAdditionalBidSignature::Trace(Visitor* visitor) const {
  TraceIfNeeded<NotShared<DOMUint8Array>>::Trace(visitor, member_key_);
TraceIfNeeded<NotShared<DOMUint8Array>>::Trace(visitor, member_signature_);
bindings::DictionaryBase::Trace(visitor);
}

void AuctionAdditionalBidSignature::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesAuctionAdditionalBidSignature) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesAuctionAdditionalBidSignature), std::cend(kOwnPropertyNamesAuctionAdditionalBidSignature));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void AuctionAdditionalBidSignature::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasKey()) {
  values[0] = ToV8Traits<NotShared<DOMUint8Array>>::ToV8(script_state, member_key_);
DCHECK(!values[0].IsEmpty());
}
if (hasSignature()) {
  values[1] = ToV8Traits<NotShared<DOMUint8Array>>::ToV8(script_state, member_signature_);
DCHECK(!values[1].IsEmpty());
}
}

const void* AuctionAdditionalBidSignature::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> AuctionAdditionalBidSignature::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void AuctionAdditionalBidSignature::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "AuctionAdditionalBidSignature";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("key");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<NotShared<DOMUint8Array>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_key_, member_key_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("signature");
if (!bindings::GetDictionaryMemberFromV8Object<NotShared<DOMUint8Array>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_signature_, member_signature_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> AuctionAdditionalBidSignature::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesAuctionAdditionalBidSignature, kOwnPropertyNamesAuctionAdditionalBidSignature);
}


}  // namespace blink
