// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_image_copy_image_bitmap.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_origin_2d_dict.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_union_gpuorigin2ddict_unsignedlongenforcerangesequence.h"
#include "third_party/blink/renderer/core/imagebitmap/image_bitmap.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesGPUImageCopyImageBitmap[] = {
"imageBitmap",
"origin",
};


}  // namespace 

GPUImageCopyImageBitmap* GPUImageCopyImageBitmap::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPUImageCopyImageBitmap* dictionary = MakeGarbageCollected<GPUImageCopyImageBitmap>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPUImageCopyImageBitmap";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPUImageCopyImageBitmap::GPUImageCopyImageBitmap() : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin2DDict::Create())) {
  
}

 GPUImageCopyImageBitmap::GPUImageCopyImageBitmap(v8::Isolate* isolate) : member_origin_(MakeGarbageCollected<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>(GPUOrigin2DDict::Create())) {
  
}













void GPUImageCopyImageBitmap::Trace(Visitor* visitor) const {
  TraceIfNeeded<Member<ImageBitmap>>::Trace(visitor, member_image_bitmap_);
TraceIfNeeded<Member<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>>::Trace(visitor, member_origin_);
bindings::DictionaryBase::Trace(visitor);
}

void GPUImageCopyImageBitmap::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesGPUImageCopyImageBitmap) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesGPUImageCopyImageBitmap), std::cend(kOwnPropertyNamesGPUImageCopyImageBitmap));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void GPUImageCopyImageBitmap::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasImageBitmap()) {
  values[0] = ToV8Traits<ImageBitmap>::ToV8(script_state, member_image_bitmap_.Get());
DCHECK(!values[0].IsEmpty());
}
if (hasOrigin()) {
  values[1] = ToV8Traits<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence>::ToV8(script_state, member_origin_.Get());
DCHECK(!values[1].IsEmpty());
}
}

const void* GPUImageCopyImageBitmap::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> GPUImageCopyImageBitmap::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void GPUImageCopyImageBitmap::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPUImageCopyImageBitmap";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("imageBitmap");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<ImageBitmap, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_image_bitmap_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("origin");
constexpr bool is_optional = false;
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionGPUOrigin2DDictOrUnsignedLongEnforceRangeSequence, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_origin_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPUImageCopyImageBitmap::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesGPUImageCopyImageBitmap, kOwnPropertyNamesGPUImageCopyImageBitmap);
}


}  // namespace blink
