// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_gpu_rasterization_state_descriptor.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesGPURasterizationStateDescriptor[] = {
"cullMode",
"depthBias",
"depthBiasClamp",
"depthBiasSlopeScale",
"frontFace",
};


}  // namespace 

GPURasterizationStateDescriptor* GPURasterizationStateDescriptor::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  GPURasterizationStateDescriptor* dictionary = MakeGarbageCollected<GPURasterizationStateDescriptor>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "GPURasterizationStateDescriptor";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 GPURasterizationStateDescriptor::GPURasterizationStateDescriptor() {
  
}

 GPURasterizationStateDescriptor::GPURasterizationStateDescriptor(v8::Isolate* isolate) {
  
}




























void GPURasterizationStateDescriptor::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8GPUCullMode>::Trace(visitor, member_cull_mode_);
TraceIfNeeded<int32_t>::Trace(visitor, member_depth_bias_);
TraceIfNeeded<float>::Trace(visitor, member_depth_bias_clamp_);
TraceIfNeeded<float>::Trace(visitor, member_depth_bias_slope_scale_);
TraceIfNeeded<V8GPUFrontFace>::Trace(visitor, member_front_face_);
bindings::DictionaryBase::Trace(visitor);
}

void GPURasterizationStateDescriptor::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesGPURasterizationStateDescriptor) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesGPURasterizationStateDescriptor), std::cend(kOwnPropertyNamesGPURasterizationStateDescriptor));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void GPURasterizationStateDescriptor::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasCullMode()) {
  values[0] = ToV8Traits<V8GPUCullMode>::ToV8(script_state, member_cull_mode_);
DCHECK(!values[0].IsEmpty());
}
if (hasDepthBias()) {
  values[1] = ToV8Traits<IDLLongEnforceRange>::ToV8(script_state, member_depth_bias_);
DCHECK(!values[1].IsEmpty());
}
if (hasDepthBiasClamp()) {
  values[2] = ToV8Traits<IDLFloat>::ToV8(script_state, member_depth_bias_clamp_);
DCHECK(!values[2].IsEmpty());
}
if (hasDepthBiasSlopeScale()) {
  values[3] = ToV8Traits<IDLFloat>::ToV8(script_state, member_depth_bias_slope_scale_);
DCHECK(!values[3].IsEmpty());
}
if (hasFrontFace()) {
  values[4] = ToV8Traits<V8GPUFrontFace>::ToV8(script_state, member_front_face_);
DCHECK(!values[4].IsEmpty());
}
}

const void* GPURasterizationStateDescriptor::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> GPURasterizationStateDescriptor::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void GPURasterizationStateDescriptor::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "GPURasterizationStateDescriptor";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("cullMode");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUCullMode, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_cull_mode_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBias");
if (!bindings::GetDictionaryMemberFromV8Object<IDLLongEnforceRange, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_depth_bias_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBiasClamp");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_depth_bias_clamp_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("depthBiasSlopeScale");
if (!bindings::GetDictionaryMemberFromV8Object<IDLFloat, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_depth_bias_slope_scale_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("frontFace");
if (!bindings::GetDictionaryMemberFromV8Object<V8GPUFrontFace, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_front_face_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> GPURasterizationStateDescriptor::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesGPURasterizationStateDescriptor, kOwnPropertyNamesGPURasterizationStateDescriptor);
}


}  // namespace blink
