// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_identity_credential_logout_r_ps_request.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesIdentityCredentialLogoutRPsRequest[] = {
"accountId",
"url",
};


}  // namespace 

IdentityCredentialLogoutRPsRequest* IdentityCredentialLogoutRPsRequest::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  IdentityCredentialLogoutRPsRequest* dictionary = MakeGarbageCollected<IdentityCredentialLogoutRPsRequest>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "IdentityCredentialLogoutRPsRequest";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 IdentityCredentialLogoutRPsRequest::IdentityCredentialLogoutRPsRequest() {
  
}

 IdentityCredentialLogoutRPsRequest::IdentityCredentialLogoutRPsRequest(v8::Isolate* isolate) {
  
}



void IdentityCredentialLogoutRPsRequest::setAccountId(const String& value) {
  member_account_id_ = value;
}

void IdentityCredentialLogoutRPsRequest::setAccountId(String&& value) {
  member_account_id_ = std::move(value);
}




void IdentityCredentialLogoutRPsRequest::setUrl(const String& value) {
  member_url_ = value;
}

void IdentityCredentialLogoutRPsRequest::setUrl(String&& value) {
  member_url_ = std::move(value);
}




void IdentityCredentialLogoutRPsRequest::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_account_id_);
TraceIfNeeded<String>::Trace(visitor, member_url_);
bindings::DictionaryBase::Trace(visitor);
}

void IdentityCredentialLogoutRPsRequest::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesIdentityCredentialLogoutRPsRequest) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesIdentityCredentialLogoutRPsRequest), std::cend(kOwnPropertyNamesIdentityCredentialLogoutRPsRequest));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void IdentityCredentialLogoutRPsRequest::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasAccountId()) {
  values[0] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_account_id_);
DCHECK(!values[0].IsEmpty());
}
if (hasUrl()) {
  values[1] = ToV8Traits<IDLUSVString>::ToV8(script_state, member_url_);
DCHECK(!values[1].IsEmpty());
}
}

const void* IdentityCredentialLogoutRPsRequest::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> IdentityCredentialLogoutRPsRequest::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void IdentityCredentialLogoutRPsRequest::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "IdentityCredentialLogoutRPsRequest";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("accountId");
constexpr bool is_required = true;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_account_id_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("url");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUSVString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_url_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> IdentityCredentialLogoutRPsRequest::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesIdentityCredentialLogoutRPsRequest, kOwnPropertyNamesIdentityCredentialLogoutRPsRequest);
}


}  // namespace blink
