// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_language_detection_result.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesLanguageDetectionResult[] = {
"confidence",
"detectedLanguage",
};


}  // namespace 

LanguageDetectionResult* LanguageDetectionResult::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  LanguageDetectionResult* dictionary = MakeGarbageCollected<LanguageDetectionResult>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "LanguageDetectionResult";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 LanguageDetectionResult::LanguageDetectionResult() {
  
}

 LanguageDetectionResult::LanguageDetectionResult(v8::Isolate* isolate) {
  
}










String LanguageDetectionResult::getDetectedLanguageOr(const String& fallback_value) const {
  if (!hasDetectedLanguage()) {
  return fallback_value;
}
return member_detected_language_;
}

String LanguageDetectionResult::getDetectedLanguageOr(String&& fallback_value) const {
  if (!hasDetectedLanguage()) {
  return std::move(fallback_value);
}
return member_detected_language_;
}

void LanguageDetectionResult::setDetectedLanguage(const String& value) {
  member_detected_language_ = value;
has_detected_language_ = true;
}

void LanguageDetectionResult::setDetectedLanguage(String&& value) {
  member_detected_language_ = std::move(value);
has_detected_language_ = true;
}




void LanguageDetectionResult::Trace(Visitor* visitor) const {
  TraceIfNeeded<double>::Trace(visitor, member_confidence_);
TraceIfNeeded<String>::Trace(visitor, member_detected_language_);
bindings::DictionaryBase::Trace(visitor);
}

void LanguageDetectionResult::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesLanguageDetectionResult) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesLanguageDetectionResult), std::cend(kOwnPropertyNamesLanguageDetectionResult));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void LanguageDetectionResult::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasConfidence()) {
  values[0] = ToV8Traits<IDLDouble>::ToV8(script_state, member_confidence_);
DCHECK(!values[0].IsEmpty());
}
if (hasDetectedLanguage()) {
  values[1] = ToV8Traits<IDLNullable<IDLString>>::ToV8(script_state, member_detected_language_);
DCHECK(!values[1].IsEmpty());
}
}

const void* LanguageDetectionResult::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> LanguageDetectionResult::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void LanguageDetectionResult::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "LanguageDetectionResult";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("confidence");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLDouble, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_confidence_, member_confidence_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("detectedLanguage");
if (!bindings::GetDictionaryMemberFromV8Object<IDLNullable<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_detected_language_, member_detected_language_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> LanguageDetectionResult::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesLanguageDetectionResult, kOwnPropertyNamesLanguageDetectionResult);
}


}  // namespace blink
