// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_LANGUAGE_DETECTION_RESULT_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_LANGUAGE_DETECTION_RESULT_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT LanguageDetectionResult : public bindings::DictionaryBase {
  
  public:
static LanguageDetectionResult* Create() {
  return MakeGarbageCollected<LanguageDetectionResult>();
}
static LanguageDetectionResult* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<LanguageDetectionResult>(isolate);
}
static LanguageDetectionResult* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  LanguageDetectionResult();
explicit  LanguageDetectionResult(v8::Isolate* isolate);

bool hasConfidence() const {
  return has_confidence_;
}
double confidence() const {
  DCHECK(hasConfidence());
return member_confidence_;
}
double getConfidenceOr(double fallback_value) const {
  if (!hasConfidence()) {
  return fallback_value;
}
return member_confidence_;
}
void setConfidence(double value) {
  member_confidence_ = value;
has_confidence_ = true;
}

bool hasDetectedLanguage() const {
  return has_detected_language_;
}
const String& detectedLanguage() const {
  DCHECK(hasDetectedLanguage());
return member_detected_language_;
}
String getDetectedLanguageOr(const String& fallback_value) const;
String getDetectedLanguageOr(String&& fallback_value) const;
void setDetectedLanguage(const String& value);
void setDetectedLanguage(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_confidence_ = false;
bool has_detected_language_ = false;

double member_confidence_;
String member_detected_language_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_LANGUAGE_DETECTION_RESULT_H_
