// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_encrypted_match_key.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_helper_share.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesPrivateAttributionEncryptedMatchKey[] = {
"shares",
};


}  // namespace 

PrivateAttributionEncryptedMatchKey* PrivateAttributionEncryptedMatchKey::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PrivateAttributionEncryptedMatchKey* dictionary = MakeGarbageCollected<PrivateAttributionEncryptedMatchKey>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PrivateAttributionEncryptedMatchKey";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PrivateAttributionEncryptedMatchKey::PrivateAttributionEncryptedMatchKey() {
  
}

 PrivateAttributionEncryptedMatchKey::PrivateAttributionEncryptedMatchKey(v8::Isolate* isolate) {
  
}



HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>> PrivateAttributionEncryptedMatchKey::getSharesOr(const HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>& fallback_value) const {
  if (!hasShares()) {
  return fallback_value;
}
return member_shares_;
}

HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>> PrivateAttributionEncryptedMatchKey::getSharesOr(HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>&& fallback_value) const {
  if (!hasShares()) {
  return std::move(fallback_value);
}
return member_shares_;
}

void PrivateAttributionEncryptedMatchKey::setShares(const HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>& value) {
  member_shares_ = value;
has_shares_ = true;
}

void PrivateAttributionEncryptedMatchKey::setShares(HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>&& value) {
  member_shares_ = std::move(value);
has_shares_ = true;
}




void PrivateAttributionEncryptedMatchKey::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>>::Trace(visitor, member_shares_);
bindings::DictionaryBase::Trace(visitor);
}

void PrivateAttributionEncryptedMatchKey::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesPrivateAttributionEncryptedMatchKey) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesPrivateAttributionEncryptedMatchKey), std::cend(kOwnPropertyNamesPrivateAttributionEncryptedMatchKey));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PrivateAttributionEncryptedMatchKey::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasShares()) {
  values[0] = ToV8Traits<IDLRecord<IDLString, PrivateAttributionHelperShare>>::ToV8(script_state, member_shares_);
DCHECK(!values[0].IsEmpty());
}
}

const void* PrivateAttributionEncryptedMatchKey::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PrivateAttributionEncryptedMatchKey::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PrivateAttributionEncryptedMatchKey::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PrivateAttributionEncryptedMatchKey";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("shares");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLRecord<IDLString, PrivateAttributionHelperShare>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_shares_, member_shares_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PrivateAttributionEncryptedMatchKey::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesPrivateAttributionEncryptedMatchKey, kOwnPropertyNamesPrivateAttributionEncryptedMatchKey);
}


}  // namespace blink
