// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_ENCRYPTED_MATCH_KEY_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_ENCRYPTED_MATCH_KEY_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class PrivateAttributionHelperShare;

class MODULES_EXPORT PrivateAttributionEncryptedMatchKey : public bindings::DictionaryBase {
  
  public:
static PrivateAttributionEncryptedMatchKey* Create() {
  return MakeGarbageCollected<PrivateAttributionEncryptedMatchKey>();
}
static PrivateAttributionEncryptedMatchKey* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PrivateAttributionEncryptedMatchKey>(isolate);
}
static PrivateAttributionEncryptedMatchKey* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PrivateAttributionEncryptedMatchKey();
explicit  PrivateAttributionEncryptedMatchKey(v8::Isolate* isolate);

bool hasShares() const {
  return has_shares_;
}
const HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>& shares() const {
  DCHECK(hasShares());
return member_shares_;
}
HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>> getSharesOr(const HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>& fallback_value) const;
HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>> getSharesOr(HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>&& fallback_value) const;
void setShares(const HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>& value);
void setShares(HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>>&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 1;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_shares_ = false;

HeapVector<std::pair<String, Member<PrivateAttributionHelperShare>>> member_shares_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_ENCRYPTED_MATCH_KEY_H_
