// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_helper_info.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesPrivateAttributionHelperInfo[] = {
"origin",
"publicKey",
};


}  // namespace 

PrivateAttributionHelperInfo* PrivateAttributionHelperInfo::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PrivateAttributionHelperInfo* dictionary = MakeGarbageCollected<PrivateAttributionHelperInfo>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PrivateAttributionHelperInfo";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PrivateAttributionHelperInfo::PrivateAttributionHelperInfo() {
  
}

 PrivateAttributionHelperInfo::PrivateAttributionHelperInfo(v8::Isolate* isolate) {
  
}



String PrivateAttributionHelperInfo::getOriginOr(const String& fallback_value) const {
  if (!hasOrigin()) {
  return fallback_value;
}
return member_origin_;
}

String PrivateAttributionHelperInfo::getOriginOr(String&& fallback_value) const {
  if (!hasOrigin()) {
  return std::move(fallback_value);
}
return member_origin_;
}

void PrivateAttributionHelperInfo::setOrigin(const String& value) {
  member_origin_ = value;
has_origin_ = true;
}

void PrivateAttributionHelperInfo::setOrigin(String&& value) {
  member_origin_ = std::move(value);
has_origin_ = true;
}




String PrivateAttributionHelperInfo::getPublicKeyOr(const String& fallback_value) const {
  if (!hasPublicKey()) {
  return fallback_value;
}
return member_public_key_;
}

String PrivateAttributionHelperInfo::getPublicKeyOr(String&& fallback_value) const {
  if (!hasPublicKey()) {
  return std::move(fallback_value);
}
return member_public_key_;
}

void PrivateAttributionHelperInfo::setPublicKey(const String& value) {
  member_public_key_ = value;
has_public_key_ = true;
}

void PrivateAttributionHelperInfo::setPublicKey(String&& value) {
  member_public_key_ = std::move(value);
has_public_key_ = true;
}




void PrivateAttributionHelperInfo::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_origin_);
TraceIfNeeded<String>::Trace(visitor, member_public_key_);
bindings::DictionaryBase::Trace(visitor);
}

void PrivateAttributionHelperInfo::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesPrivateAttributionHelperInfo) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesPrivateAttributionHelperInfo), std::cend(kOwnPropertyNamesPrivateAttributionHelperInfo));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PrivateAttributionHelperInfo::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasOrigin()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_origin_);
DCHECK(!values[0].IsEmpty());
}
if (hasPublicKey()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_public_key_);
DCHECK(!values[1].IsEmpty());
}
}

const void* PrivateAttributionHelperInfo::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PrivateAttributionHelperInfo::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PrivateAttributionHelperInfo::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PrivateAttributionHelperInfo";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("origin");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_origin_, member_origin_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("publicKey");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_public_key_, member_public_key_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PrivateAttributionHelperInfo::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesPrivateAttributionHelperInfo, kOwnPropertyNamesPrivateAttributionHelperInfo);
}


}  // namespace blink
