// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_INFO_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_INFO_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT PrivateAttributionHelperInfo : public bindings::DictionaryBase {
  
  public:
static PrivateAttributionHelperInfo* Create() {
  return MakeGarbageCollected<PrivateAttributionHelperInfo>();
}
static PrivateAttributionHelperInfo* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PrivateAttributionHelperInfo>(isolate);
}
static PrivateAttributionHelperInfo* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PrivateAttributionHelperInfo();
explicit  PrivateAttributionHelperInfo(v8::Isolate* isolate);

bool hasOrigin() const {
  return has_origin_;
}
const String& origin() const {
  DCHECK(hasOrigin());
return member_origin_;
}
String getOriginOr(const String& fallback_value) const;
String getOriginOr(String&& fallback_value) const;
void setOrigin(const String& value);
void setOrigin(String&& value);

bool hasPublicKey() const {
  return has_public_key_;
}
const String& publicKey() const {
  DCHECK(hasPublicKey());
return member_public_key_;
}
String getPublicKeyOr(const String& fallback_value) const;
String getPublicKeyOr(String&& fallback_value) const;
void setPublicKey(const String& value);
void setPublicKey(String&& value);




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_origin_ = false;
bool has_public_key_ = false;

String member_origin_;
String member_public_key_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_INFO_H_
