// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_SHARE_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_SHARE_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT PrivateAttributionHelperShare : public bindings::DictionaryBase {
  
  public:
static PrivateAttributionHelperShare* Create() {
  return MakeGarbageCollected<PrivateAttributionHelperShare>();
}
static PrivateAttributionHelperShare* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<PrivateAttributionHelperShare>(isolate);
}
static PrivateAttributionHelperShare* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  PrivateAttributionHelperShare();
explicit  PrivateAttributionHelperShare(v8::Isolate* isolate);

bool hasEncryptedShare() const {
  return has_encrypted_share_;
}
DOMArrayBuffer* encryptedShare() const {
  DCHECK(hasEncryptedShare());
return member_encrypted_share_.Get();
}
DOMArrayBuffer* getEncryptedShareOr(DOMArrayBuffer* fallback_value) const {
  if (!hasEncryptedShare()) {
  return fallback_value;
}
return member_encrypted_share_.Get();
}
void setEncryptedShare(DOMArrayBuffer* value) {
  member_encrypted_share_ = value;
has_encrypted_share_ = true;
DCHECK(member_encrypted_share_);
}

bool hasKeyId() const {
  return has_key_id_;
}
uint8_t keyId() const {
  DCHECK(hasKeyId());
return member_key_id_;
}
uint8_t getKeyIdOr(uint8_t fallback_value) const {
  if (!hasKeyId()) {
  return fallback_value;
}
return member_key_id_;
}
void setKeyId(uint8_t value) {
  member_key_id_ = value;
has_key_id_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
static constexpr size_t kBasePropertyCount = 0;
static constexpr size_t kOwnPropertyCount = 2;
static constexpr size_t kTotalPropertyCount = kBasePropertyCount + kOwnPropertyCount;
void FillTemplateProperties(WTF::Vector<std::string_view>& properties) const override;
void FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const;


void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
const void* TemplateKey() const override;
v8::Local<v8::Object> FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const override;
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_encrypted_share_ = false;
bool has_key_id_ = false;

Member<DOMArrayBuffer> member_encrypted_share_;
uint8_t member_key_id_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_PRIVATE_ATTRIBUTION_HELPER_SHARE_H_
