// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_network.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_private_attribution_helper_info.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesPrivateAttributionNetwork[] = {
"helpers",
"id",
};


}  // namespace 

PrivateAttributionNetwork* PrivateAttributionNetwork::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  PrivateAttributionNetwork* dictionary = MakeGarbageCollected<PrivateAttributionNetwork>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "PrivateAttributionNetwork";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 PrivateAttributionNetwork::PrivateAttributionNetwork() {
  
}

 PrivateAttributionNetwork::PrivateAttributionNetwork(v8::Isolate* isolate) {
  
}



HeapVector<Member<PrivateAttributionHelperInfo>> PrivateAttributionNetwork::getHelpersOr(const HeapVector<Member<PrivateAttributionHelperInfo>>& fallback_value) const {
  if (!hasHelpers()) {
  return fallback_value;
}
return member_helpers_;
}

HeapVector<Member<PrivateAttributionHelperInfo>> PrivateAttributionNetwork::getHelpersOr(HeapVector<Member<PrivateAttributionHelperInfo>>&& fallback_value) const {
  if (!hasHelpers()) {
  return std::move(fallback_value);
}
return member_helpers_;
}

void PrivateAttributionNetwork::setHelpers(const HeapVector<Member<PrivateAttributionHelperInfo>>& value) {
  member_helpers_ = value;
has_helpers_ = true;
}

void PrivateAttributionNetwork::setHelpers(HeapVector<Member<PrivateAttributionHelperInfo>>&& value) {
  member_helpers_ = std::move(value);
has_helpers_ = true;
}











void PrivateAttributionNetwork::Trace(Visitor* visitor) const {
  TraceIfNeeded<HeapVector<Member<PrivateAttributionHelperInfo>>>::Trace(visitor, member_helpers_);
TraceIfNeeded<uint32_t>::Trace(visitor, member_id_);
bindings::DictionaryBase::Trace(visitor);
}

void PrivateAttributionNetwork::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesPrivateAttributionNetwork) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesPrivateAttributionNetwork), std::cend(kOwnPropertyNamesPrivateAttributionNetwork));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void PrivateAttributionNetwork::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasHelpers()) {
  values[0] = ToV8Traits<IDLSequence<PrivateAttributionHelperInfo>>::ToV8(script_state, member_helpers_);
DCHECK(!values[0].IsEmpty());
}
if (hasId()) {
  values[1] = ToV8Traits<IDLUnsignedLong>::ToV8(script_state, member_id_);
DCHECK(!values[1].IsEmpty());
}
}

const void* PrivateAttributionNetwork::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> PrivateAttributionNetwork::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void PrivateAttributionNetwork::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "PrivateAttributionNetwork";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("helpers");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<PrivateAttributionHelperInfo>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_helpers_, member_helpers_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("id");
if (!bindings::GetDictionaryMemberFromV8Object<IDLUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_id_, member_id_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> PrivateAttributionNetwork::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesPrivateAttributionNetwork, kOwnPropertyNamesPrivateAttributionNetwork);
}


}  // namespace blink
