// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_ice_parameters.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



namespace  {

const std::string_view kOwnPropertyNamesRTCIceParameters[] = {
"password",
"usernameFragment",
};


}  // namespace 

RTCIceParameters* RTCIceParameters::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  RTCIceParameters* dictionary = MakeGarbageCollected<RTCIceParameters>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "RTCIceParameters";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (exception_state.HadException()) [[unlikely]] {
  return nullptr;
}
return dictionary;
}

 RTCIceParameters::RTCIceParameters() {
  
}

 RTCIceParameters::RTCIceParameters(v8::Isolate* isolate) {
  
}



String RTCIceParameters::getPasswordOr(const String& fallback_value) const {
  if (!hasPassword()) {
  return fallback_value;
}
return member_password_;
}

String RTCIceParameters::getPasswordOr(String&& fallback_value) const {
  if (!hasPassword()) {
  return std::move(fallback_value);
}
return member_password_;
}

void RTCIceParameters::setPassword(const String& value) {
  member_password_ = value;
has_password_ = true;
}

void RTCIceParameters::setPassword(String&& value) {
  member_password_ = std::move(value);
has_password_ = true;
}




String RTCIceParameters::getUsernameFragmentOr(const String& fallback_value) const {
  if (!hasUsernameFragment()) {
  return fallback_value;
}
return member_username_fragment_;
}

String RTCIceParameters::getUsernameFragmentOr(String&& fallback_value) const {
  if (!hasUsernameFragment()) {
  return std::move(fallback_value);
}
return member_username_fragment_;
}

void RTCIceParameters::setUsernameFragment(const String& value) {
  member_username_fragment_ = value;
has_username_fragment_ = true;
}

void RTCIceParameters::setUsernameFragment(String&& value) {
  member_username_fragment_ = std::move(value);
has_username_fragment_ = true;
}




void RTCIceParameters::Trace(Visitor* visitor) const {
  TraceIfNeeded<String>::Trace(visitor, member_password_);
TraceIfNeeded<String>::Trace(visitor, member_username_fragment_);
bindings::DictionaryBase::Trace(visitor);
}

void RTCIceParameters::FillTemplateProperties(WTF::Vector<std::string_view>& properties) const {
  static_assert(std::size(kOwnPropertyNamesRTCIceParameters) == kOwnPropertyCount);
properties.AppendRange(std::cbegin(kOwnPropertyNamesRTCIceParameters), std::cend(kOwnPropertyNamesRTCIceParameters));
DCHECK_EQ(properties.size(), kTotalPropertyCount);
}

void RTCIceParameters::FillValuesImpl(ScriptState* script_state, base::span<v8::MaybeLocal<v8::Value>> values) const {
  CHECK_EQ(kOwnPropertyCount, values.size());
if (hasPassword()) {
  values[0] = ToV8Traits<IDLString>::ToV8(script_state, member_password_);
DCHECK(!values[0].IsEmpty());
}
if (hasUsernameFragment()) {
  values[1] = ToV8Traits<IDLString>::ToV8(script_state, member_username_fragment_);
DCHECK(!values[1].IsEmpty());
}
}

const void* RTCIceParameters::TemplateKey() const {
  static const void *s_key = &s_key;
return s_key;
}

v8::Local<v8::Object> RTCIceParameters::FillValues(ScriptState* script_state, v8::Local<v8::DictionaryTemplate> dict_template) const {
  v8::MaybeLocal<v8::Value> values[kTotalPropertyCount];
FillValuesImpl(script_state, values);
return dict_template->NewInstance(script_state->GetContext(), values);
}

void RTCIceParameters::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  TryRethrowScope rethrow_scope(isolate, exception_state);
const char* const class_like_name = "RTCIceParameters";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(v8::ExceptionContext::kAttributeGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("password");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_password_, member_password_, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("usernameFragment");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), has_username_fragment_, member_username_fragment_, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> RTCIceParameters::GetV8OwnMemberNames(v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnPropertyNamesRTCIceParameters, kOwnPropertyNamesRTCIceParameters);
}


}  // namespace blink
